#ifndef BASEWIDGET_H  //grr... we hates header guards, but
#define BASEWIDGET_H  //no other choice when you subclass mocced files

#include <QImage>
#include <QLayout>
#include <QSlider>
#include <QWidget>

#include "HandyScrollArea.h"
#include "MiniMap.h"

class BaseWidget :
	public QWidget
{
	Q_OBJECT

public:
	BaseWidget( char* l1, char* l2 );
	BaseWidget( QImage l1, QImage l2 );
	~BaseWidget(void);

	void setScale( double s );

	QColor getMaskColor() { return main->getMaskColor(); };
	QColor getConflictColor() { return conflict; };
	QColor getEraserColor() { return eraser; };
	int getTolerance() { return tolerance * 10; };

signals:
	void showMessage( QString m, int msec );

public slots:
	void nil0 () {};
	void setConflictColor( QColor c ) { conflict = c; };
	void setMaskColor( QColor m );
	virtual void setEraserColor( QColor e ) { eraser = e; };
	virtual void setTolerance( int dec ) { tolerance = dec / 10.0; };

protected slots:
	void nil1 () {};
	void message( QString m );
	void useLeg1();
	void useLeg2();

protected:
	QImage leg1;
	QImage leg2;

	MiniMap* p1;
	MiniMap* p2;

	QColor conflict;
	QColor eraser;

	ImageProjector* main;
	HandyScrollArea* scroll;
	QHBoxLayout* main_l;

	QSlider* slider;

	float tolerance;

private:
	void initBaseWidget();
};

#endif

