#include <QColor>
#include <QDialog>

class ColorSample;
class ToleranceSwatch;

class ColorOptsDialog :
	public QDialog
{
	Q_OBJECT
public:
	ColorOptsDialog( QColor m, QColor c, QColor e, int t );
	~ColorOptsDialog(void);

signals:
	void nil0();
	void setMaskColor( QColor m );
	void setConflictColor( QColor c );
	void setEraserColor( QColor c );
	void setTolerance( int t );

private slots:
	void nil1() {};
	void chooseMaskColor();
	void chooseConflictColor();
	void chooseEraserColor();

	void okay();

private:
	ColorSample* sample;
	ToleranceSwatch* swatch;
};

class ColorSample : public QWidget
{
public:
	QColor maskC;
	QColor conflictC;
	QColor eraserC;

protected:
	void paintEvent( QPaintEvent* );
};

class ToleranceSwatch : public QWidget
{
	Q_OBJECT
public:
	int tolerance;

public slots:
	void nil0() {};
	void setTolerance( int );

protected:
	void paintEvent( QPaintEvent* );
};

