#include "BaseWidget.h"
#include "MergeEditor.h"

class CalamariWindow;

class MergeWidget :
	public BaseWidget
{
	Q_OBJECT

public:
	MergeWidget( char* base, char* theirs, char* yours );
	MergeWidget( QImage base, QImage theirs, QImage yours );
	~MergeWidget(void);

	QImage getBase() { return base; };
	QImage getTheirs() { return leg1; };
	QImage getYours() { return leg2; };

	//Alpha merging interface functions.
	void beDone();
	bool done() { return allDone; };
	QImage mergeResult() { return merge; };

signals:
	void enableSave( bool );

public slots:
	void nil0() {};
	void autoMerge();
	void setTheirsMask( bool on );
	void setYoursMask( bool on );
	void setConflictMask( bool on );

	void setBrushSize( int px );
	void setEraserSize( int px );
	void eraserToggle( bool on );
	void paintToggle( bool on );
	void sprayToggle( bool on );

	void setEraserColor( QColor e );

	bool save();
	void saveAs();
	void setResult( char* );

	void exportStencils();

private slots:
	void nil1() {};
	void imageEdited() { emit enableSave( true ); };

private:
	MergeEditor* editor; 

	QImage merge;
	QImage base;
	QBitmap base_theirs;
	float base_theirs_t;
	QBitmap base_yours;
	float base_yours_t;
	QBitmap conflicts;
	float conflicts_t;

	QString result;
	QString resultFormat;

	void freshenConflicts();

	void initMergeWidget();

	void spawnAlphaWindow();
	CalamariWindow* alphaWindow;
	bool allDone;
};
