#include <QtGui/QApplication>
#include <QMessageBox>

#include "CalamariWindow.h"

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
	a.connect(&a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()));

	CalamariWindow* w = 0x0;
	switch ( argc )
	{
	case 3:
		w = new CalamariWindow( argv[1], argv[2] );
		break;
	case 4:
		w = new CalamariWindow( argv[1], argv[2], argv[3] );
		break;
	case 5:
		w = new CalamariWindow( argv[1], argv[2], argv[3], argv[4] );
		break;
	default:
		QMessageBox::critical( 0, "CALAMARI error", "Usage:\n       calamari IMAGE1 IMAGE2\n       calamari BASE THEIRS YOURS [RESULT]" );
		return 1;
	}

	w->show();
	w->setGeometry( w->x(), w->y(), 500, 350 );
    return a.exec();
}
